#ifndef sameboy_application_h
#define sameboy_application_h
	#include <gtk/gtk.h>
	#include <Core/gb.h>

	struct CliOptionData {
		gchar *config_path;
		gchar *boot_rom_path;
		gboolean fullscreen;
		GB_model_t model;
		gboolean force_software_renderer;
	};

	#define SAMEBOY_APPLICATION_TYPE (sameboy_application_get_type())
	G_DECLARE_FINAL_TYPE(SameBoyApplication, sameboy_application, SAMEBOY, APPLICATION, GtkApplication)

	SameBoyApplication *sameboy_application_new(void);
	void sameboy_application_preferences_signal_connect(SameBoyApplication *app, const gchar *detailed_signal, GCallback c_handler, gpointer data);
	struct CliOptionData *sameboy_application_get_cli_options(SameBoyApplication *self);
#endif
