#ifndef main_menu_h
#define main_menu_h

#include <gtk/gtk.h>
#include <Core/gb.h>
#include "main_window.h"

#define MAIN_MENU_TYPE (main_menu_get_type())
G_DECLARE_FINAL_TYPE(MainMenu, main_menu, SAMEBOY, MAIN_MENU, GtkMenuBar)

MainMenu *main_menu_new();
void main_menu_setup( MainMenu *self
                    , char *model_string
                    , MainWindow *main_window
                    , bool (*on_change_model)(GtkWidget *, GtkWidget *, gpointer)
                    , bool (*on_change_linked_device)(GtkWidget *, GtkWidget *, gpointer)
                    );

#endif
